VERSION 5.00
Begin VB.Form frmHelp 
   BorderStyle     =   4  'Fixed ToolWindow
   ClientHeight    =   7248
   ClientLeft      =   48
   ClientTop       =   288
   ClientWidth     =   6372
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7248
   ScaleWidth      =   6372
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton HelpCloseButton 
      Caption         =   "Close"
      Height          =   375
      Left            =   5160
      TabIndex        =   1
      Top             =   6720
      Width           =   975
   End
   Begin VB.TextBox txtHelp 
      Height          =   6315
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "frmHelp.frx":0000
      Top             =   240
      Width           =   5895
   End
End
Attribute VB_Name = "frmHelp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags_ As Long) As Long

' From ...\Microsoft Visual Studio\Common\Tools\Winapi\WIN32API.TXT ...

' SetWindowPos Flags
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2
Const SWP_NOZORDER = &H4
Const SWP_NOREDRAW = &H8
Const SWP_NOACTIVATE = &H10
Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
Const SWP_SHOWWINDOW = &H40
Const SWP_HIDEWINDOW = &H80
Const SWP_NOCOPYBITS = &H100
Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering

Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Const SWP_NOREPOSITION = SWP_NOOWNERZORDER

' SetWindowPos() hwndInsertAfter values
Const HWND_TOP = 0
Const HWND_BOTTOM = 1
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2

Private Sub HelpCloseButton_Click()
    Unload Me
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 27 Then Unload Me '  Escape key
End Sub

Private Sub Form_Load()
    Dim x As Long
    Dim s As String
    
    s = "Bar Code Scanner Details..." & "                Version " & App.Major & "." & App.Minor & "." & App.Revision _
      & vbCrLf & vbCrLf & vbCrLf

    s = s _
      & "The scanner firmware decodes many of the common 1D (1-dimensional) bar code symbologies. " _
      & "It has been tested with the following symbologies..." & vbCrLf & vbCrLf

    s = s _
      & "     UPC A" & vbCrLf _
      & "     UPC A + 2 digit supplemental" & vbCrLf _
      & "     UPC A + 5 digit supplemental" & vbCrLf _
      & "     UPC E  (Shown both compressed and expanded)" & vbCrLf _
      & "     EAN 13  (European Article Numbering)" & vbCrLf _
      & "     EAN 13 + 2 digit supplemental" & vbCrLf _
      & "     EAN 13 + 5 digit supplemental" & vbCrLf _
      & "     EAN 8" & vbCrLf

    s = s _
      & "     JAN 13  (Japanese Article Numbering)" & vbCrLf _
      & "     JAN 13 + 2 digit supplemental" & vbCrLf _
      & "     JAN 13 + 5 digit supplemental" & vbCrLf _
      & "     ISBN  (International Standard Book Number)" & vbCrLf

    s = s _
      & "     ISBN + 2 digit supplemental" & vbCrLf _
      & "     ISBN + 5 digit supplemental" & vbCrLf _
      & "     ISSN  (International Standard Serial Number for periodicals)" & vbCrLf _
      & "     ISSN + 2 digit supplemental" & vbCrLf _
      & "     ISSN + 5 digit supplemental" & vbCrLf
    
    s = s _
      & "     ISMN  (International Standard Music Number)" & vbCrLf _
      & "     ISMN + 2 digit supplemental" & vbCrLf _
      & "     ISMN + 5 digit supplemental" & vbCrLf _
      & "     Code 39" & vbCrLf _
      & "     Code 128" & vbCrLf _
      & "     Interleaved 2-of-5" & vbCrLf _
      & "     Codabar" & vbCrLf & vbCrLf
    
    s = s _
      & "     cue:Cat proprietary (CC!)" & vbCrLf _
      & "     cue:Cat proprietary (CC^)" & vbCrLf & vbCrLf
      
                    ' Note: VB maximum number of continued lines is ten.
    s = s _
      & "The scanner provides a 3-character code for the bar code type. I provide a spelled-out description " _
      & "of the symbologies listed above, and just the 3-character code for any others. If you see another " _
      & "3-character code, let me know and I'll try to determine what symbology it is and add it to the program. " & vbCrLf & vbCrLf _
      & "The cue:Cat scanner's own proprietary bar codes, seen in some magazine ads and in some electronics stores' " _
      & "catalogs have 3-letter codes which appear to begin with 'CC'. So far, I've seen 'CC!' and 'CC^' ... " _
      & "there may be others." & vbCrLf & vbCrLf
    
    s = s _
      & "For symbologies where the data is typically printed in groups of digits under the bar code (UPC, EAN, etc.) the " _
      & "display of the data has spaces inserted to group the decoded digits in a similar fashion for readability." _
      & vbCrLf & vbCrLf _

    s = s _
      & "UPC A bar codes on coupons contain a code defining the value of the coupon. This is displayed by the program using " _
      & "data from the Uniform Code Council which is current as of July 2001." _
      & vbCrLf & vbCrLf

    s = s _
      & "The first two or three digits of an EAN-13 barcode identify the country in which the manufacturer's identification " _
      & "code was assigned (not necessarily the country in which the goods were manufactured). This information is displayed " _
      & "from data which is current as of 2002." _
      & vbCrLf & vbCrLf

    s = s _
      & "UPC E is a special case, smaller footprint version of the UPC bar code where for certain kinds of data containing " _
      & "many zeros, the zeros may be removed, with the last digit determining the method of restoring the missing zeros " _
      & "to produce the equivalent full-sized UPC A value. (All UPC E bar codes represent a 'zero-suppressed' version of a " _
      & "legitemate UPC A code.) The display of a scanned UPC E bar code will be shown compressed and expanded." _
      & vbCrLf & vbCrLf

    s = s _
      & "The scanned data is also placed in the Windows Clipboard (without added spaces) so that it may be pasted into " _
      & "other Windows applications. " _
      & vbCrLf & vbCrLf

    s = s _
      & "The scanner is a 'keyboard wedge' device - the encrypted scan data enters the PC as though it had been typed " _
      & "in on the keyboard. This program receives that input in the text-entry area at the bottom of the window and " _
      & "decrypts and processes the data when the last character from the scanner, a Carriage-Return character, 'pushes' " _
      & "the [Input:] button in the lower-left corner of the window, which is the window's 'default' button (thicker black " _
      & "border than the other button). The program works when the text-entry area has the 'focus' and the [Input:] button " _
      & "is the default botton. (The program starts this way.) You can 'Tab' to the [Quit] button, and both the focus and " _
      & "the default will shift to that button allowing you to exit without using the mouse. Tab again, and the focus returns " _
      & "to the text-entry area while the default returns to the [Input:] button - and you are ready to scan again." _
      & vbCrLf & vbCrLf

    s = s _
      & "This program must be the currently-selected Windows foreground program when scanning. If you click on another " _
      & "program's window then it will become the foreground program and it will receive all keyboard input. Therefore, " _
      & "if you are scanning and pasting data into, say, a word processor, then be sure to click on this program's window " _
      & "(or Alt-Tab to switch programs) to get back to this program, or the next scan's raw encrypted data will be " _
      & "'keyed into' the other program." _
      & vbCrLf & vbCrLf & vbCrLf

    s = s _
      & "The 'Always on Top' selection of the Options menu will cause the scanner window to remain visible in front of other " _
      & "windows when checked." _
      & vbCrLf & vbCrLf _
      & "The 'Append to Clipboard Data...' selection of the Options menu controls adding a tab character, a " _
      & "Carriage-Return/Line-Feed sequence, or nothing (the default) to the end of the data in the clipboard to aid in" _
      & " using the pasted data in a data entry setting. " _
      & vbCrLf & vbCrLf & vbCrLf

    s = s _
      & "Scanner defficiencies..." _
      & vbCrLf & vbCrLf _
      & "ISBN and ISSN are actually EAN 13 bar codes beginning with 977 (ISSN) and 978 or 979 (ISBN). The scanner " _
      & "correctly recognizes ISSN and the 978-style ISBN but identifies the 979-style ISBN an ordinary EAN 13. " _
      & "I check the first three digits of EAN 13 bar codes and correctly identify the 979-style ISBN codes." _
      & vbCrLf & vbCrLf
      
    s = s _
      & "JAN is actually EAN beginning with 45 or 49 (the EAN country codes for Japan). The scanner " _
      & "correctly recognizes 49 as JAN but identifies 45 as an ordinary EAN 13. " _
      & "I check the first two digits of EAN 13 bar codes and correctly identify the 45-style JAN codes." _
      & vbCrLf & vbCrLf
      
    s = s _
      & "The scanner does not decode the check digit in a UPC E bar code. A UPC E bar code has a start code, six " _
      & "data characters, and a stop code. The check digit is encoded in the choice of odd-parity and even-parity " _
      & "characters used for the six data characters. I provide a message to the effect that the check sum character " _
      & "is not decoded by the scanner when a UPC E is scanned, and I provide what the checksum SHOULD be. (The 'Number System' character for UPC E is always zero, " _
      & "and is not encoded, but rather is assumed to be present. The scanner does correctly invent the zero and place it " _
      & "at the beginning of the decoded data.)" _
      & vbCrLf & vbCrLf

    s = s _
      & "The scanner does not decode which of the five possible start and stop characters (A, B, C, D, or E) was " _
      & "used in a Codabar bar code. Codabar is a numeric bar code symbology, and the choice of start and stop " _
      & "characters can be used to encode additional information. I provide a message to the effect that the start " _
      & "and stop codes used were not decoded." _
      & vbCrLf & vbCrLf & vbCrLf

    s = s _
      & "Other information..." _
      & vbCrLf & vbCrLf _
      & "This program enables the use of the small, free scanner as a general-purpose bar code scanner and " _
      & "symbology-identifying tool." _
      & vbCrLf & vbCrLf _
      & "This program provides no functionality related in any way to the scanning of the proprietary (type 'CCx') bar " _
      & "codes in connection with Web browsing technology for purposes of going to the scanned advertizer's web site or " _
      & "collecting demographic information about the visitor to such a web site - a technology for which " _
      & "Digital:Convergence Corporation holds a patent. Therefore, this software also cannot be used to defeat the "

    s = s _
      & "collecting of such demographic information, as it contains no means to implement the visiting of the scanned " _
      & "advertizer's sites, and it makes no attempt to hide or scramble the unit serial number which is returned from " _
      & "the unit on every scan." _
      & vbCrLf & vbCrLf & vbCrLf _
      & "This program, the source code, and the VisualBasic 6.0 Project files are placed in the Public Domain." _
      & vbCrLf & vbCrLf

    s = s _
      & "The original source for the Visual Basic project I started with is in 'meow.zip' available on several Internet " _
      & "sites. It has the basic symbol decoding. Thanks to that (anonymous) author for coding the decryption, and for " _
      & "showing me the technique of making a 'default button' to catch the enter-key at the end of the scanner string. " _
      & "I used my own several years' experience working with bar codes to flesh out the program to clarify the symbology " _
      & "types, format some types for readability, and to identify the three scanner defects described above." _
      & vbCrLf & vbCrLf _
      & "Having looked at most of the available Windows programs for this scanner, I believe this to be the most full-featured " _
      & "program with regard to using this device as a general-purpose bar code scanner." _
      & vbCrLf & vbCrLf
    
    s = s _
      & "The latest version may be found at my web site..." _
      & vbCrLf & vbCrLf _
      & "    http://ChuckSomerville.com/" _
      & vbCrLf & vbCrLf _
      & "...and you can E-mail questions or comments to..." _
      & vbCrLf & vbCrLf _
      & "    chuck.somerville@kodak.com"

    txtHelp.Text = s
    
    x = SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    
End Sub
