VERSION 5.00
Begin VB.Form main 
   Caption         =   "Cat Scratch Fever"
   ClientHeight    =   2820
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   5625
   Icon            =   "whiskas.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   188
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   375
   Begin VB.CommandButton exit 
      Caption         =   "Exit"
      Height          =   420
      Left            =   4365
      TabIndex        =   6
      Top             =   2280
      Width           =   855
   End
   Begin VB.TextBox ScannerInput 
      Height          =   285
      Left            =   735
      TabIndex        =   0
      ToolTipText     =   "This automatically fills in when you scan"
      Top             =   1800
      Width           =   4800
   End
   Begin VB.CommandButton convert 
      Caption         =   "Convert"
      Default         =   -1  'True
      Height          =   180
      Left            =   1365
      TabIndex        =   1
      Top             =   1845
      Width           =   1560
   End
   Begin VB.Label Label5 
      Caption         =   "Raw Input"
      Height          =   540
      Left            =   225
      TabIndex        =   11
      Top             =   1200
      Width           =   495
   End
   Begin VB.Label upc 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   1110
      TabIndex        =   10
      ToolTipText     =   "This is the barcode. It is copied into the clipboard automatically"
      Top             =   120
      Width           =   3705
   End
   Begin VB.Label code 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   4155
      TabIndex        =   9
      ToolTipText     =   "This is the barcode format type"
      Top             =   690
      Width           =   1125
   End
   Begin VB.Label serial 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   1320
      TabIndex        =   8
      ToolTipText     =   "Yup, the Kat knows who you are!"
      Top             =   690
      Width           =   1800
   End
   Begin VB.Label raw 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   720
      TabIndex        =   7
      ToolTipText     =   "This is the uninterpreted device output"
      Top             =   1245
      Width           =   4815
   End
   Begin VB.Label Label4 
      Caption         =   "Barcode Type:"
      Height          =   495
      Left            =   3465
      TabIndex        =   5
      Top             =   645
      Width           =   675
   End
   Begin VB.Label Label3 
      Caption         =   "Your Device Serial number:"
      Height          =   375
      Left            =   210
      TabIndex        =   4
      Top             =   645
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Product Barcode:"
      Height          =   375
      Left            =   210
      TabIndex        =   3
      Top             =   75
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Input:"
      Height          =   255
      Left            =   225
      TabIndex        =   2
      Top             =   1800
      Width           =   495
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu ClipAdd 
         Caption         =   "Add to &Clipboard :"
         Begin VB.Menu EndTab 
            Caption         =   "&Tab"
         End
         Begin VB.Menu EndCRLF 
            Caption         =   "&Return"
            Checked         =   -1  'True
         End
      End
      Begin VB.Menu mnuTopmost 
         Caption         =   "&Always on Top"
      End
   End
End
Attribute VB_Name = "main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags_ As Long) As Long

Private Const conHwndTopmost = -1
Private Const conHwndNoTopmost = -2
Private Const conSwpNoActivate = &H10
Private Const conSwpShowWindow = &H40
Private Const seq = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-"

Private Function decode_barcode(inputstring As String) As String
    Dim x As Integer
    Dim temp0 As Integer
    Dim temp1 As Integer
    Dim temp2 As Integer
    Dim temp3 As Integer
    Dim temp4 As Integer

    decode_barcode = ""

    For x = 1 To Len(inputstring) Step 4
        temp1 = InStr(seq, Mid$(inputstring, x, 1)) - 1
        temp2 = InStr(seq, Mid$(inputstring, x + 1, 1)) - 1
        temp0 = ((temp1 And 63) * 4) + ((temp2 And 48) / 16)
        decode_barcode = decode_barcode & Chr$(temp0 Xor 67)
        If Len(inputstring) - x > 1 Then
            temp3 = InStr(seq, Mid$(inputstring, x + 2, 1)) - 1
            temp0 = ((temp2 And 15) * 16) + ((temp3 And 60) / 4)
            decode_barcode = decode_barcode & Chr$(temp0 Xor 67)
            If Len(inputstring) - x > 2 Then
                temp4 = InStr(seq, Mid$(inputstring, x + 3, 1)) - 1
                temp0 = ((temp3 And 3) * 64) + (temp4 And 63)
                decode_barcode = decode_barcode & Chr$(temp0 Xor 67)
            End If
        End If
    Next x
End Function

Private Function cuedecode(inputstring As String) As String
    Dim x As Integer
    Dim temp0 As Integer
    Dim tmp As String
    
    cuedecode = "C 01 "
    
    For x = 1 To Len(inputstring)
        temp0 = Asc(Mid$(inputstring, x, 1)) Xor 32
        tmp = Format(temp0, "00")
        cuedecode = cuedecode & tmp & " "
    Next x
    cuedecode = Mid$(cuedecode, 1, Len(cuedecode) - 1)
End Function

Private Sub AutoPaste_Click()

End Sub

Private Sub convert_Click()
    Dim x As Integer
    Dim ScannerIn As String
    Dim ScannerSerial As String
    Dim ScannerCode As String
    Dim Scannerupc As String
    
    Beep
    x = InStr(ScannerInput.Text, ".")
    If x = 0 Then
        ScannerInput.Text = ""
        Exit Sub
    End If
    ScannerIn = Mid$(ScannerInput.Text, x + 1, Len(ScannerInput.Text) - x)
    x = InStr(ScannerIn, ".")
    ScannerSerial = Mid$(ScannerIn, 1, x - 1)
    ScannerIn = Mid$(ScannerIn, x + 1, Len(ScannerIn) - x)
    x = InStr(ScannerIn, ".")
    ScannerCode = Mid$(ScannerIn, 1, x - 1)
    ScannerIn = Mid$(ScannerIn, x + 1, Len(ScannerIn) - x)
    x = InStr(ScannerIn, ".")
    Scannerupc = Mid$(ScannerIn, 1, x - 1)
    
    raw.Caption = ScannerInput.Text
    serial.Caption = ""
    upc.Caption = ""

    serial.Caption = decode_barcode(ScannerSerial)
    code.Caption = decode_barcode(ScannerCode)
    If code.Caption = "CC!" Then
        upc.Caption = cuedecode(decode_barcode(Scannerupc))
    Else
        upc.Caption = decode_barcode(Scannerupc)
    End If
    
    ScannerInput.Text = ""
    ClipString = upc.Caption
    If EndTab.Checked = True Then ClipString = ClipString + vbTab
    If EndCRLF.Checked = True Then ClipString = ClipString + vbNewLine
    'If EndPGDN.Checked = True Then ClipString = ClipString + Chr(vbKeyPageDown)
    Clipboard.Clear
    Clipboard.SetText ClipString
    
    If upc.Caption = "040293153502" Then MsgBox "Why did you scan the barcode that came in your Scanner package?"
    
End Sub

Private Sub EndCRLF_Click()
    EndCRLF.Checked = Not EndCRLF.Checked
End Sub

Private Sub EndPGDN_Click()
    EndPGDN.Checked = Not EndPGDN.Checked
End Sub

Private Sub EndTab_Click()
    EndTab.Checked = Not EndTab.Checked
End Sub

Private Sub exit_Click()
    Unload Me
End Sub

Private Sub mnuTopmost_Click()
    mnuTopmost.Checked = Not mnuTopmost.Checked
    If mnuTopmost.Checked Then
        SetWindowPos hwnd, conHwndTopmost, 0, 0, 385, 85, conSwpShowWindow
    Else
        SetWindowPos hwnd, conHwndNoTopmost, 0, 0, 385, 240, conSwpShowWindow
    End If
End Sub
