VERSION 5.00
Begin VB.Form main 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bar Code Scanner"
   ClientHeight    =   2508
   ClientLeft      =   48
   ClientTop       =   612
   ClientWidth     =   11748
   Icon            =   "whiskas.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   209
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   979
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox ScannerInput 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   10.02
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   960
      TabIndex        =   0
      ToolTipText     =   "  Scanner data entered here (scanner is a keyboard wedge) "
      Top             =   1920
      Width           =   10560
   End
   Begin VB.CommandButton EnterTrap 
      Appearance      =   0  'Flat
      Caption         =   "Input:"
      Default         =   -1  'True
      Height          =   345
      Left            =   180
      MousePointer    =   12  'No Drop
      TabIndex        =   2
      TabStop         =   0   'False
      ToolTipText     =   " The  [Enter]  from the scanner (a keyboard wedge) causes this (Default) button to ""press"" "
      Top             =   1920
      Width           =   570
   End
   Begin VB.Label Label5 
      Caption         =   "Raw Data"
      Height          =   540
      Left            =   225
      TabIndex        =   9
      Top             =   1320
      Width           =   495
   End
   Begin VB.Label barcodeData 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   10.02
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   960
      TabIndex        =   8
      ToolTipText     =   " Bar code data. (copied to clipboard) "
      Top             =   240
      Width           =   10560
   End
   Begin VB.Label code 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   10.02
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   960
      TabIndex        =   7
      ToolTipText     =   " barcode symbology "
      Top             =   840
      Width           =   10560
   End
   Begin VB.Label serial 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   10.02
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   8640
      TabIndex        =   6
      ToolTipText     =   " Serial number of this bar code scanner "
      Top             =   1365
      Width           =   2880
   End
   Begin VB.Label raw 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   10.02
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   960
      TabIndex        =   5
      ToolTipText     =   " This is the uninterpreted device output "
      Top             =   1365
      Width           =   6720
   End
   Begin VB.Label Label4 
      Caption         =   "Barcode Type:"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   765
      Width           =   675
   End
   Begin VB.Label Label3 
      Caption         =   "Serial number:"
      Height          =   375
      Left            =   8040
      TabIndex        =   3
      Top             =   1320
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Barcode Value:"
      Height          =   375
      Left            =   210
      TabIndex        =   1
      Top             =   195
      Width           =   735
   End
   Begin VB.Menu File 
      Caption         =   "&File"
      Begin VB.Menu FileExit 
         Caption         =   "E&xit          "
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu mnuTopmost 
         Caption         =   "&Always on Top"
      End
      Begin VB.Menu xx 
         Caption         =   "-"
      End
      Begin VB.Menu ClipAdd 
         Caption         =   "Apend to &clipboard data..."
         Begin VB.Menu EndTab 
            Caption         =   "&Tab"
         End
         Begin VB.Menu EndCRLF 
            Caption         =   "&Return"
         End
      End
   End
   Begin VB.Menu Help 
      Caption         =   "&Help"
      Begin VB.Menu HelpHelp 
         Caption         =   "Bar code help          "
         Shortcut        =   {F1}
      End
      Begin VB.Menu xxx 
         Caption         =   "-"
      End
      Begin VB.Menu HelpAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags_ As Long) As Long

' From ...\Microsoft Visual Studio\Common\Tools\Winapi\WIN32API.TXT ...

' SetWindowPos Flags
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2
Const SWP_NOZORDER = &H4
Const SWP_NOREDRAW = &H8
Const SWP_NOACTIVATE = &H10
Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
Const SWP_SHOWWINDOW = &H40
Const SWP_HIDEWINDOW = &H80
Const SWP_NOCOPYBITS = &H100
Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering

Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Const SWP_NOREPOSITION = SWP_NOOWNERZORDER

' SetWindowPos() hwndInsertAfter values
Const HWND_TOP = 0
Const HWND_BOTTOM = 1
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2

Private Const seq = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-"

Private Sub Form_Load()
    main.Caption = "Bar Code Scanner - Version " & App.Major & "." & App.Minor & "." & App.Revision
End Sub

Private Function decode_barcode(inputstring As String) As String
    Dim x As Integer
    Dim temp0 As Integer
    Dim temp1 As Integer
    Dim temp2 As Integer
    Dim temp3 As Integer
    Dim temp4 As Integer

    decode_barcode = ""

    For x = 1 To Len(inputstring) Step 4
        temp1 = InStr(seq, Mid$(inputstring, x, 1)) - 1
        temp2 = InStr(seq, Mid$(inputstring, x + 1, 1)) - 1
        temp0 = ((temp1 And 63) * 4) + ((temp2 And 48) / 16)
        decode_barcode = decode_barcode & Chr$(temp0 Xor 67)
        If Len(inputstring) - x > 1 Then
            temp3 = InStr(seq, Mid$(inputstring, x + 2, 1)) - 1
            temp0 = ((temp2 And 15) * 16) + ((temp3 And 60) / 4)
            decode_barcode = decode_barcode & Chr$(temp0 Xor 67)
            If Len(inputstring) - x > 2 Then
                temp4 = InStr(seq, Mid$(inputstring, x + 3, 1)) - 1
                temp0 = ((temp3 And 3) * 64) + (temp4 And 63)
                decode_barcode = decode_barcode & Chr$(temp0 Xor 67)
            End If
        End If
    Next x
End Function

Private Function cuedecode(inputstring As String) As String
    Dim x As Integer
    Dim temp0 As Integer
    Dim tmp As String
    
    cuedecode = "C 01 "
    
    For x = 1 To Len(inputstring)
        temp0 = Asc(Mid$(inputstring, x, 1)) Xor 32
        tmp = Format(temp0, "00")
        cuedecode = cuedecode & tmp & " "
    Next x
    cuedecode = Mid$(cuedecode, 1, Len(cuedecode) - 1)
End Function

Private Sub EnterTrap_Click()
    Dim x As Integer
    Dim ScannerIn As String
    Dim ScannerSerial As String
    Dim ScannerCode As String
    Dim Scannerupc As String
    Dim sCode As String
    Dim sData As String, sData2 As String, sCC As String
    Dim ClipString As String
    Dim SP As String * 1, SP4 As String * 4
    
    SP = " ": SP4 = "    "
    
    Beep
    x = InStr(ScannerInput.Text, ".")
    If x = 0 Then
        ScannerInput.Text = ""
        Exit Sub
    End If
    ScannerIn = Mid$(ScannerInput.Text, x + 1, Len(ScannerInput.Text) - x)
    x = InStr(ScannerIn, ".")
    ScannerSerial = Mid$(ScannerIn, 1, x - 1)
    ScannerIn = Mid$(ScannerIn, x + 1, Len(ScannerIn) - x)
    x = InStr(ScannerIn, ".")
    ScannerCode = Mid$(ScannerIn, 1, x - 1)
    ScannerIn = Mid$(ScannerIn, x + 1, Len(ScannerIn) - x)
    x = InStr(ScannerIn, ".")
    Scannerupc = Mid$(ScannerIn, 1, x - 1)
    
    raw.Caption = ScannerInput.Text
    serial.Caption = ""
    barcodeData.Caption = ""

    serial.Caption = decode_barcode(ScannerSerial)
    sCode = decode_barcode(ScannerCode)
    If Left(sCode, 2) = "CC" Then ' special Cue:Cat bar code decoding
        sData = cuedecode(decode_barcode(Scannerupc))
    Else          ' all other symbologies
        sData = decode_barcode(Scannerupc)
    End If
    
    Select Case sCode  '  symbology type

    '  Convert known 3-character codes to readable description of symbology type
    '  and format bar code data for readability for selected symbologies.
    '
    '  The best general reference for all bar code technologies:
    '
    '      The Bar Code Book, Third Edition
    '      by Roger C. Palmer
    '      Helmers Publishing, 1995
    '      ISBN 0-911261-09-5
    
    Case "UPA"
        code.Caption = " UPC  A"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 5) & SP & Mid(sData, 7, 5) & SP & Mid(sData, 12, 1)
        If Left(sData, 1) = "5" Then barcodeData.Caption = barcodeData.Caption & "   (Coupon: " & CouponValue(Mid(sData, 10, 2)) & ")"
    Case "UA2"
        code.Caption = " UPC  A  +  2 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 5) & SP & Mid(sData, 7, 5) & SP & Mid(sData, 12, 1) & SP4 & Right(sData, 2)
        If Left(sData, 1) = "5" Then barcodeData.Caption = barcodeData.Caption & "   (Coupon: " & CouponValue(Mid(sData, 10, 2)) & ")"
    Case "UA5"
        code.Caption = " UPC  A  +  5 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 5) & SP & Mid(sData, 7, 5) & SP & Mid(sData, 12, 1) & SP4 & Right(sData, 5)
        If Left(sData, 1) = "5" Then barcodeData.Caption = barcodeData.Caption & "   (Coupon: " & CouponValue(Mid(sData, 10, 2)) & ")"
    Case "UPE"
            code.Caption = " UPC E  (Compressed UPC A)"
            
            Select Case Right(sData, 1)  ' Reference: http://www.barcodeisland.com/upce.phtml (description's right, table's wrong - 7/10/2001)
            Case "0", "1", "2"
                sData2 = Left(sData, 3) & Mid(sData, 7, 1) & "0000" & Mid(sData, 4, 3)
            Case "3"
                sData2 = Left(sData, 4) & "00000" & Mid(sData, 5, 2)
            Case "4"
                sData2 = Left(sData, 5) & "00000" & Mid(sData, 6, 1)
            Case "5" To "9"
                sData2 = Left(sData, 6) & "0000" & Mid(sData, 7, 1)
            Case Else
                MsgBox "The expansion of a UPC E bar code to the equivalent UPC A value has failed " _
                     & "due to an unrecognized final UPC E character (" & Right(sData, 1) & ")." _
                     & vbCr & vbCr & "Only un-expanded UPC E value will be displayed.", _
                     vbExclamation, _
                     "UPC E Expansion - Internal Error"
                     barcodeData.Caption = barcodeData.Caption & "UPC A Expansion Error"
                     sData2 = "Expansion Error"
                     GoTo noExpansion
            End Select

            sCC = UPCAchecksum(sData2) ' Get what checksum SHOULD be for the expanded UPCA
            barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2) & SP & sCC & "  ("
            barcodeData.Caption = barcodeData.Caption & "Expanded UPCA: " _
                                  & Left(sData2, 1) & SP & Mid(sData2, 2, 5) & SP & Mid(sData2, 7, 5) _
                                  & SP & sCC
noExpansion:
            barcodeData.Caption = barcodeData.Caption & ") Note: Scanner didn't decode UPCE checksum"
            sData = sData & sCC & " (" & sData2 & sCC & ")"
    Case "E13"
        If Left(sData, 3) = "979" Then  '  ISMN is EAN 13 beginning with 979.
            code.Caption = " ISMN"      '  Reference: http://www.adams1.com/pub/russadam/upccode.html
        Else
            If Left(sData, 2) = "45" Then  '  Scanner catches 49 as JAN but not 45
                code.Caption = " JAN  13"
            Else
                code.Caption = " EAN  13,  Country info: " + decodeEAN(sData)
            End If
        End If
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6)
    Case "E32"
        If Left(sData, 3) = "979" Then  '  ISMN is EAN 13 beginning with 979.
            code.Caption = " ISMN  +  2 digit supplemental"
        Else
            If Left(sData, 2) = "45" Then  '  Scanner catches 49 as JAN but not 45
                code.Caption = " JAN  13  +  2 digit supplemental"
            Else
                code.Caption = " EAN  13  +  2 digit supplemental,  Country info: " + decodeEAN(sData)
            End If
        End If
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 2)
    Case "E35"
        If Left(sData, 3) = "979" Then  '  ISMN is EAN 13 beginning with 979.
            code.Caption = " ISMN  +  5 digit supplemental"
        Else
            If Left(sData, 2) = "45" Then  '  Scanner catches 49 as JAN but not 45
                code.Caption = " JAN  13  +  5 digit supplemental"
            Else
                code.Caption = " EAN  13  +  5 digit supplemental,  Country info: " + decodeEAN(sData)
            End If
        End If
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 5)
    Case "E08"
        code.Caption = " EAN  8"
        barcodeData.Caption = Left(sData, 4) & SP & Right(sData, 4)
    Case "J13"
        code.Caption = " JAN 13"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6)
    Case "J32"
        code.Caption = " JAN 13  +  2 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 2)
    Case "J35"
        code.Caption = " JAN 13  +  5 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 5)
    Case "IBN"
        code.Caption = " ISBN"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6)
    Case "IB2"
        code.Caption = " ISBN  +  2 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 2)
    Case "IB5"
        code.Caption = " ISBN  +  5 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 5)
    Case "ISN"
        code.Caption = " ISSN"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6)
    Case "IS2"
        code.Caption = " ISSN  +  2 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 2)
    Case "IS5"
        code.Caption = " ISSN  +  5 digit supplemental"
        barcodeData.Caption = Left(sData, 1) & SP & Mid(sData, 2, 6) & SP & Mid(sData, 8, 6) & SP4 & Right(sData, 5)
    Case "128"
        code.Caption = " Code 128"
        barcodeData.Caption = sData
    Case "E28"
        code.Caption = " EAN 128"
        barcodeData.Caption = sData
    Case "C39"
        code.Caption = " Code 39"
        barcodeData.Caption = sData
    Case "ITF"
        code.Caption = " Interleaved  2-of-5"
        barcodeData.Caption = sData
    Case "CBR"
        code.Caption = " Codabar"
        barcodeData.Caption = "? " & sData & " ?    (Scanner does not decode Codabar start/stop)"
    Case Else   ' Other values.
        If Left(sCode, 2) = "CC" Then
            code.Caption = " Free scanner proprietary (" & sCode & ")"
        Else
            code.Caption = sCode
        End If
        barcodeData.Caption = sData
    End Select

    ScannerInput.Text = ""
    ClipString = sData
    If EndTab.Checked = True Then ClipString = ClipString & vbTab
    If EndCRLF.Checked = True Then ClipString = ClipString & vbNewLine
    Clipboard.Clear
    Clipboard.SetText ClipString
    
End Sub

Private Sub EndCRLF_Click()
    EndCRLF.Checked = Not EndCRLF.Checked
    If EndCRLF.Checked Then EndTab.Checked = False
End Sub

Private Sub EndTab_Click()
    EndTab.Checked = Not EndTab.Checked
    If EndTab.Checked Then EndCRLF.Checked = False
End Sub

Private Sub EnterTrap_GotFocus()
    ScannerInput.SetFocus
End Sub

Private Sub FileExit_Click()
    End
End Sub

Private Sub HelpAbout_Click()
    Dim x As Long, LF As String * 1
    LF = Chr(10)
    x = MsgBox(App.Comments & LF & LF _
      & "Version " & App.Major & "." & App.Minor & "." & App.Revision & LF & LF _
      & App.LegalCopyright, _
      vbOKOnly, "About Bar Code Scanner")
End Sub

Private Sub HelpHelp_Click()
    frmHelp.Show vbModal, Me
End Sub

Private Sub mnuTopmost_Click()
    Dim x As Long
    mnuTopmost.Checked = Not mnuTopmost.Checked
    
    If mnuTopmost.Checked Then
        x = SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    Else
        x = SetWindowPos(Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    End If
    
End Sub

Private Function CouponValue(ValueCode As String) As String
    Select Case ValueCode ' Current as of July 1 2000
        Case "00": CouponValue = "Checker Intervention"
        Case "01": CouponValue = "Free Merchandise"
        Case "02": CouponValue = "Buy 4 or more, get 1 free (same product)"
        Case "03": CouponValue = "$1.10"
        Case "04": CouponValue = "$1.35"
        Case "05": CouponValue = "$1.40"
        Case "06": CouponValue = "$1.60"
        Case "07": CouponValue = "Buy 3 or more, get $1.50 off"
        Case "08": CouponValue = "Buy 2 or more, get $3.00 off"
        Case "09": CouponValue = "Buy 3 or more, get $2.00 off"
        Case "10": CouponValue = "$0.10"
        Case "11": CouponValue = "$1.85"
        Case "12": CouponValue = "$0.12"
        Case "13": CouponValue = "Buy 4 or more, get $1.00 off"
        Case "14": CouponValue = "Buy 1, get 1 free (same product)"
        Case "15": CouponValue = "$0.15"
        Case "16": CouponValue = "Buy 2, get 1 free (same product)"
        Case "17": CouponValue = "Reserved for future use"
        Case "18": CouponValue = "$2.60"
        Case "19": CouponValue = "Buy 3, get 1 free (same product)"
        Case "20": CouponValue = "$0.20"
        Case "21": CouponValue = "Buy 2 or more, get $0.35 off"
        Case "22": CouponValue = "Buy 2 or more, get $0.40 off"
        Case "23": CouponValue = "Buy 2 or more, get $0.45 off"
        Case "24": CouponValue = "Buy 2, get $0.50 off"
        Case "25": CouponValue = "$0.25"
        Case "26": CouponValue = "$2.85"
        Case "27": CouponValue = "Reserved for future use"
        Case "28": CouponValue = "Buy 2, get $0.55 off"
        Case "29": CouponValue = "$0.29"
        Case "30": CouponValue = "$0.30"
        Case "31": CouponValue = "Buy 2 or more, get $0.60 off"
        Case "32": CouponValue = "Buy 2 or more, get $0.75 off"
        Case "33": CouponValue = "Buy 2, get $1.00 off"
        Case "34": CouponValue = "Buy 2 or more, get $1.25 off"
        Case "35": CouponValue = "$0.35"
        Case "36": CouponValue = "Buy 2 or more, get $1.50 off"
        Case "37": CouponValue = "Buy 3 or more, get $0.25 off"
        Case "38": CouponValue = "Buy 3 or more, get $0.30 off"
        Case "39": CouponValue = "$0.39"
        Case "40": CouponValue = "$0.40"
        Case "41": CouponValue = "Buy 3 or more, get $0.50 off"
        Case "42": CouponValue = "Buy 3 or more, get $1.00 off"
        Case "43": CouponValue = "Buy 2 or more, get $1.10 off"
        Case "44": CouponValue = "Buy 2 or more, get $1.35 off"
        Case "45": CouponValue = "$0.45"
        Case "46": CouponValue = "Buy 2 or more, get $1.60 off"
        Case "47": CouponValue = "Buy 2 or more, get $1.75 off"
        Case "48": CouponValue = "Buy 2 or more, get $1.85 off"
        Case "49": CouponValue = "$0.49"
        Case "50": CouponValue = "$0.50"
        Case "51": CouponValue = "Buy 2 or more, get $2.00 off"
        Case "52": CouponValue = "Buy 3 or more, get $0.55 off"
        Case "53": CouponValue = "Buy 2 or more, get $0.10 off"
        Case "54": CouponValue = "Buy 2 or more, get $0.15 off"
        Case "55": CouponValue = "$0.55"
        Case "56": CouponValue = "Buy 2 or more, get $0.20 off"
        Case "57": CouponValue = "Buy 2, get $0.25 off"
        Case "58": CouponValue = "Buy 2, get $0.30 off"
        Case "59": CouponValue = "$0.59"
        Case "60": CouponValue = "$0.60"
        Case "61": CouponValue = "$10.00"
        Case "62": CouponValue = "$9.50"
        Case "63": CouponValue = "$9.00"
        Case "64": CouponValue = "$8.50"
        Case "65": CouponValue = "$0.65"
        Case "66": CouponValue = "$8.00"
        Case "67": CouponValue = "$7.50"
        Case "68": CouponValue = "$7.00"
        Case "69": CouponValue = "$0.69"
        Case "70": CouponValue = "$0.70"
        Case "71": CouponValue = "$6.50"
        Case "72": CouponValue = "$6.00"
        Case "73": CouponValue = "$5.50"
        Case "74": CouponValue = "$5.00"
        Case "75": CouponValue = "$0.75"
        Case "76": CouponValue = "$1.00"
        Case "77": CouponValue = "$1.25"
        Case "78": CouponValue = "$1.50"
        Case "79": CouponValue = "$0.79"
        Case "80": CouponValue = "$0.80"
        Case "81": CouponValue = "$1.75"
        Case "82": CouponValue = "$2.00"
        Case "83": CouponValue = "$2.25"
        Case "84": CouponValue = "$2.50"
        Case "85": CouponValue = "$0.85"
        Case "86": CouponValue = "$2.75"
        Case "87": CouponValue = "$3.00"
        Case "88": CouponValue = "$3.25"
        Case "89": CouponValue = "$0.89"
        Case "90": CouponValue = "$0.90"
        Case "91": CouponValue = "$3.50"
        Case "92": CouponValue = "$3.75"
        Case "93": CouponValue = "$4.00"
        Case "94": CouponValue = "Reserved for future use"
        Case "95": CouponValue = "$0.95"
        Case "96": CouponValue = "$4.50"
        Case "97": CouponValue = "Reserved for future use"
        Case "98": CouponValue = "Buy 2 or more, get $0.65 off"
        Case "99": CouponValue = "$0.99"
        Case Else: CouponValue = "Unknown Value Code"
    End Select
End Function
Function decodeEAN(sCode As String) As String
    Dim cc As Integer
    cc = Val(Left(sCode, 3)) ' EAN Country Code
    Select Case cc
        Case 0 To 139
            decodeEAN = "USA & Canada"
        Case 200 To 299
            decodeEAN = "In-store numbers"
        Case 300 To 379
            decodeEAN = "GENCOD-EAN France"
        Case 380
            decodeEAN = "BCCI (Bulgaria)"
        Case 383
            decodeEAN = "EAN Slovenija"
        Case 385
            decodeEAN = "EAN Croatia"
        Case 387
            decodeEAN = "EAN-BIH (Bosnia-Herzegovina)"
        Case 400 To 440
            decodeEAN = "CCG (Germany)"
        Case 450 To 499
            decodeEAN = "Distribution Code Center DCC (Japan)"
        Case 460 To 469
            decodeEAN = "UNISCAN - EAN Russia (Russian Federation)"
        Case 471
            decodeEAN = "EAN Taiwan"
        Case 474
            decodeEAN = "EAN Estonia"
        Case 475
            decodeEAN = "EAN Latvia"
        Case 476
            decodeEAN = "EAN Azerbaijan"
        Case 477
            decodeEAN = "EAN Lithuania"
        Case 478
            decodeEAN = "EAN Uzbekistan"
        Case 479
            decodeEAN = "EAN Sri Lanka"
        Case 480
            decodeEAN = "PANC (Philippines)"
        Case 481
            decodeEAN = "EAN Belarus"
        Case 482
            decodeEAN = "EAN Ukraine"
        Case 484
            decodeEAN = "EAN Moldova"
        Case 485
            decodeEAN = "EAN Armenia"
        Case 486
            decodeEAN = "EAN Georgia"
        Case 487
            decodeEAN = "EAN Kazakhstan"
        Case 489
            decodeEAN = "HKANA (Hong-Kong)"
        Case 500 To 509
            decodeEAN = "e.centre (Great Britain)"
        Case 520
            decodeEAN = "EAN HELLAS (Greece)"
        Case 528
            decodeEAN = "EAN Lebanon"
        Case 529
            decodeEAN = "EAN Cyprus"
        Case 531
            decodeEAN = "EAN-MAC (FYR Macedonia)"
        Case 535
            decodeEAN = "EAN Malta"
        Case 539
            decodeEAN = "EAN Ireland"
        Case 540 To 549
            decodeEAN = "EAN Belgium/Luxembourg"
        Case 560
            decodeEAN = "CODIPOR (Portugal)"
        Case 569
            decodeEAN = "EAN Iceland"
        Case 570 To 579
            decodeEAN = "EAN Danmark"
        Case 590
            decodeEAN = "EAN Poland"
        Case 594
            decodeEAN = "EAN Romania"
        Case 599
            decodeEAN = "EAN Hungary"
        Case 600 To 601
            decodeEAN = "EAN South Africa"
        Case 608
            decodeEAN = "EAN Bahrain"
        Case 609
            decodeEAN = "EAN Mauritius"
        Case 611
            decodeEAN = "EAN Maroc (Morocco)"
        Case 613
            decodeEAN = "EAN Algerie (Algeria)"
        Case 616
            decodeEAN = "EAN Kenya"
        Case 619
            decodeEAN = "Tunicode (Tunisia)"
        Case 621
            decodeEAN = "EAN Syria"
        Case 622
            decodeEAN = "EAN Egypt"
        Case 624
            decodeEAN = "EAN Libya"
        Case 625
            decodeEAN = "EAN Jordan"
        Case 626
            decodeEAN = "EAN Iran"
        Case 627
            decodeEAN = "EAN Kuwait"
        Case 628
            decodeEAN = "EAN Saudi Arabia"
        Case 629
            decodeEAN = "EAN Emirates"
        Case 640 To 649
            decodeEAN = "EAN Finland"
        Case 690 To 695
            decodeEAN = "Article Numbering Centre of China - ANCC"
        Case 700 To 709
            decodeEAN = "EAN Norge (Norway)"
        Case 729
            decodeEAN = "Israeli Bar Code Association - EAN Israel"
        Case 730 To 739
            decodeEAN = "EAN Sweden"
        Case 740
            decodeEAN = "EAN Guatemala"
        Case 741
            decodeEAN = "EAN El Salvador"
        Case 742
            decodeEAN = "EAN Honduras"
        Case 743
            decodeEAN = "EAN Nicaragua"
        Case 744
            decodeEAN = "EAN Costa Rica"
        Case 745
            decodeEAN = "EAN Panama"
        Case 746
            decodeEAN = "EAN Republica Dominicana"
        Case 750
            decodeEAN = "AMECE (Mexico)"
        Case 759
            decodeEAN = "EAN Venezuela"
        Case 760 To 769
            decodeEAN = "EAN Switzerland"
        Case 770
            decodeEAN = "IAC (Colombia)"
        Case 773
            decodeEAN = "EAN Uruguay"
        Case 775
            decodeEAN = "EAN Peru"
        Case 777
            decodeEAN = "EAN Bolivia"
        Case 779
            decodeEAN = "CODIGO - EAN Argentina"
        Case 780
            decodeEAN = "EAN Chile"
        Case 784
            decodeEAN = "EAN Paraguay"
        Case 786
            decodeEAN = "ECOP (Ecuador)"
        Case 789 To 790
            decodeEAN = "EAN Brasil"
        Case 800 To 839
            decodeEAN = "INDICOD (Italy)"
        Case 840 To 849
            decodeEAN = "AECOC (Spain)"
        Case 850
            decodeEAN = "Camera de Comercio de la Republica de Cuba"
        Case 858
            decodeEAN = "EAN Slovakia"
        Case 859
            decodeEAN = "EAN Czech"
        Case 860
            decodeEAN = "EAN YU (Yugoslavia)"
        Case 867
            decodeEAN = "EAN DPR Korea (North Korea)"
        Case 869
            decodeEAN = "UCCET (Turkey)"
        Case 870 To 879
            decodeEAN = "EAN Nederland"
        Case 880
            decodeEAN = "EAN Korea (South Korea)"
        Case 885
            decodeEAN = "EAN Thailand"
        Case 888
            decodeEAN = "SANC (Singapore)"
        Case 890
            decodeEAN = "EAN India"
        Case 893
            decodeEAN = "EAN Vietnam"
        Case 899
            decodeEAN = "EAN Indonesia"
        Case 900 To 919
            decodeEAN = "EAN Austria"
        Case 930 To 939
            decodeEAN = "EAN Australia"
        Case 940 To 949
            decodeEAN = "EAN New Zealand"
        Case 955
            decodeEAN = "EAN Malaysia"
        Case 958
            decodeEAN = "EAN Macau"
        Case 977
            decodeEAN = "Periodicals (ISSN)"
        Case 978 To 979
            decodeEAN = "Books (ISBN)"
        Case 980
            decodeEAN = "Refund receipts"
        Case 981 To 982
            decodeEAN = "Common currency coupons"
        Case 990 To 999
            decodeEAN = "Coupons"
    End Select
End Function

Private Function UPCAchecksum(digits As String) As String
    Dim nOdd As Integer, nEven As Integer, i As Integer, n As Integer

    If Len(digits) <> 11 Then
        MsgBox "Error: Function UPCAchecksum(digits) passed " & Str(Len(digits)) & "digits, expected 11.", vbExclamation, "Internal error"
        UPCAchecksum = "?"
        Exit Function
    End If

    nOdd = 0: nEven = 0

    For i = 1 To 11 Step 2 ' Odd digits
        nOdd = nOdd + Val(Mid(digits, i, 1))
    Next i

    For i = 2 To 10 Step 2 ' Even digits
        nEven = nEven + Val(Mid(digits, i, 1))
    Next i

    n = ((nOdd * 3) + nEven) Mod 10

    UPCAchecksum = LTrim(Str((10 - n) Mod 10))

End Function
